import autoroot
import os
import shutil
import argparse


def main(args):
    images_dir = os.path.join(args.data_dir, "images")
    test_dir = os.path.join(args.data_dir, "SCSPAR24_Testdata")
    images_dir_list = os.listdir(images_dir)
    for i, img in enumerate(os.listdir(test_dir)):
        extension = img.split(".")[-1]
        shutil.copy(os.path.join(test_dir, img), os.path.join(images_dir, f"{len(images_dir_list) + 1 + i}.{extension}"))


if __name__ == "__main__":
    parser = argparse.ArgumentParser(description="Combine VRL PAR Challenge Dataset")
    parser.add_argument(
        "--data_dir",
        type=str,
        default=os.environ["data_dir"],
        help="Data directory",
    )
    args = parser.parse_args()
    main(args)